Registry for Performance Metrics
RFC 0000
BCP NNN
Marcelo Bagnulo
Universidad Carlos III de Madrid
Av. Universidad 30
Leganes
Madrid
28911
Spain
34 91 6249500
marcelo@it.uc3m.es
http://www.it.uc3m.es
Benoit Claise
Cisco Systems, Inc.
De Kleetlaan 6a b1
1831 Diegem
Belgium
bclaise@cisco.com
Philip Eardley
BT
Adastral Park, Martlesham Heath
Ipswich
United Kingdom
philip.eardley@bt.com
Al Morton
AT&T Labs
200 Laurel Avenue South
Middletown
NJ
United States of America
acmorton@att.com
Aamer Akhter
Consultant
118 Timber Hitch
Cary
NC
United States of America
aakhter@gmail.com
May 2020
This document defines the format for the IANA Performance Metrics Registry. This document also gives a set of guidelines for Registered Performance Metric requesters and reviewers.
Introduction
The IETF specifies and uses Performance Metrics of protocols and applications transported over its protocols. Performance metrics are an important part of network operations using IETF protocols, and [RFC6390] specifies guidelines for their development.
The definition and use of Performance Metrics in the IETF have been fostered in various working groups (WGs). Most notably:
- The "IP Performance Metrics" (IPPM) WG is the WG primarily focusing on Performance Metrics definition at the IETF.
- The "Benchmarking Methodology" WG (BMWG) defines many Performance Metrics for use in laboratory benchmarking of internetworking technologies.
- The "Metric Blocks for use with RTCP's Extended Report Framework" (XRBLOCK) WG (concluded) specified many Performance Metrics related to "RTP Control Protocol Extended Reports (RTCP XR)" [RFC3611], which establishes a framework to allow new information to be conveyed in RTCP, supplementing the original report blocks defined in "RTP: A Transport Protocol for Real-Time Applications" [RFC3550].
- The "IP Flow Information eXport" (IPFIX) WG (concluded) specified an Internet Assigned Numbers Authority (IANA) process for new Information Elements. Some Information Elements related to Performance Metrics are proposed on a regular basis.
- The "Performance Metrics for Other Layers" (PMOL) WG (concluded) defined some Performance Metrics related to Session Initiation Protocol (SIP) voice quality [RFC6035].
It is expected that more Performance Metrics will be defined in the future -- not only IP-based metrics but also metrics that are protocol specific and application specific.
Despite the importance of Performance Metrics, there are two related problems for the industry:
- First, ensuring that when one party requests that another party measure (or report or in some way act on) a particular Performance Metric, both parties have exactly the same understanding of what Performance Metric is being referred to.
- Second, discovering which Performance Metrics have been specified, to avoid developing a new Performance Metric that is very similar but not quite interoperable.
These problems can be addressed by creating a registry of performance metrics.
The usual way in which the IETF organizes registries is with the IANA, and there is currently no Performance Metrics Registry maintained by the IANA.
This document requests that IANA create and maintain a Performance Metrics Registry, according to the maintenance procedures and the Performance Metrics Registry format defined in this memo. The resulting Performance Metrics Registry is for use by the IETF and others. Although the Registry formatting specifications herein are primarily for registry creation by IANA, any other organization that wishes to create a performance metrics registry may use the same formatting specifications for their purposes. The authors make no guarantee of the registry format's applicability to any possible set of Performance Metrics envisaged by other organizations, but we encourage others to apply it. In the remainder of this document, unless we explicitly say otherwise, we will refer to the IANA-maintained Performance Metrics Registry as simply the Performance Metrics Registry.
Terminology
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
Performance Metric:
A quantitative measure of performance, targeted to an IETF-specified protocol or targeted to an application transported over an IETF-specified protocol. Examples of Performance Metrics are the FTP response time for a complete file download, the DNS response time to resolve the IP address(es), a database logging time, etc. This definition is consistent with the definition of a metric in [RFC2330] and broader than the definition of a performance metric in [RFC6390].
Registered Performance Metric:
A Performance Metric expressed as an entry in the Performance Metrics Registry, administered by IANA. Such a performance metric has met all of the registry review criteria defined in this document in order to be included in the registry.
Performance Metrics Registry:
The IANA registry containing Registered Performance Metrics.
Proprietary Registry:
A set of metrics that are registered in a proprietary registry, as opposed to the Performance Metrics Registry.
Performance Metrics Experts:
A group of designated experts [RFC8126] selected by the IESG to validate the Performance Metrics before updating the Performance Metrics Registry. The Performance Metrics Experts work closely with IANA.
Parameter:
An input factor defined as a variable in the definition of a Performance Metric. A Parameter is a numerical or other specified factor forming one of a set that defines a metric or sets the conditions of its operation. All Parameters must be known in order to make a measurement using a metric and interpret the results. There are two types of Parameters: Fixed and Runtime. For the Fixed Parameters, the value of the variable is specified in the Performance Metrics Registry entry and different Fixed Parameter values results in different Registered Performance Metrics. For the Runtime Parameters, the value of the variable is defined when the metric measurement method is executed and a given Registered Performance Metric supports multiple values for the parameter. Although Runtime Parameters do not change the fundamental nature of the Performance Metric's definition, some have substantial influence on the network property being assessed and interpretation of the results.
Note: Consider the case of packet loss in the following two Active Measurement Method cases. The first case is packet loss as background loss where the Runtime Parameter set includes a very sparse Poisson stream and only characterizes the times when packets were lost. Actual user streams likely see much higher loss at these times, due to tail drop or radio errors. The second case is packet loss as the inverse of throughput where the Runtime Parameter set includes a very dense, bursty stream, and characterizes the loss experienced by a stream that approximates a user stream. These are both "loss metrics", but the difference in interpretation of the results is highly dependent on the Runtime Parameters (at least), to the extreme where we are actually using loss to infer its compliment: delivered throughput.
Active Measurement Methods:
Methods of Measurement conducted on traffic that serves only the purpose of measurement and is generated for that reason alone, and whose traffic characteristics are known a priori. The complete definition of Active Methods is specified in Section 3.4 of [RFC7799]. Examples of Active Measurement Methods are the measurement methods for the one-way delay metric defined in [RFC7679] and the round-trip delay metric defined in [RFC2681].
Passive Measurement Methods:
Methods of Measurement conducted on network traffic, generated by either (1) the end users or (2) network elements that would exist regardless of whether the measurement was being conducted or not. The complete definition of Passive Methods is specified in Section 3.6 of [RFC7799]. One characteristic of Passive Measurement Methods is that sensitive information may be observed and, as a consequence, stored in the measurement system.
Hybrid Measurement Methods:
Methods of Measurement that use a combination of Active Methods and Passive Methods, to assess Active Metrics, Passive Metrics, or new metrics derived from the a priori knowledge and observations of the stream of interest. The complete definition of Hybrid Methods is specified in Section 3.8 of [RFC7799].
Scope
This document is intended for two different audiences:
1. For those defining new Registered Performance Metrics, it provides specifications and best practices to be used in deciding which Registered Performance Metrics are useful for a measurement study, instructions for writing the text for each column of the Registered Performance Metrics, and information on the supporting documentation required for the new Performance Metrics Registry entry (up to and including the publication of one or more immutable documents such as an RFC).
2. For the appointed Performance Metrics Experts and for IANA personnel administering the new IANA Performance Metrics Registry, it defines a set of acceptance criteria against which these proposed Registered Performance Metrics should be evaluated.
In addition, this document may be useful for other organizations who are defining a performance metrics registry of their own and may reuse the features of the Performance Metrics Registry defined in this document.
This Performance Metrics Registry is applicable to Performance Metrics issued from Active Measurement, Passive Measurement, and any other form of Performance Metric. This registry is designed to encompass Performance Metrics developed throughout the IETF and especially for the technologies specified in the following working groups: IPPM, XRBLOCK, IPFIX, and BMWG. This document analyzes a prior attempt to set up a Performance Metrics Registry and the reasons why this design was inadequate [RFC6248]. Finally, this document gives a set of guidelines for requesters and expert reviewers of candidate Registered Performance Metrics.
This document makes no attempt to populate the Performance Metrics Registry with initial entries; the related memo [RFCYYY1] defines the initial set of registry entries.
Motivations for the Performance Metrics Registry
In this section, we detail several motivations for the Performance Metrics Registry.
Interoperability
As with any IETF registry, the primary intention is to manage the registration of identifiers for use within one or more protocols. In the particular case of the Performance Metrics Registry, there are two types of protocols that will use the Performance Metrics in the Performance Metrics Registry during their operation (by referring to the index values):
Control protocol:
This type of protocol is used to allow one entity to request that another entity perform a measurement using a specific metric defined by the Performance Metrics Registry. One particular example is the Large-scale Measurement of Broadband Performance (LMAP) framework [RFC7594]. Using the LMAP terminology, the Performance Metrics Registry is used in the LMAP Control Protocol to allow a Controller to schedule a measurement task for one or more Measurement Agents.
In order to enable this use case, the entries in the Performance Metrics Registry must be sufficiently defined to allow a Measurement Agent implementation to trigger a specific measurement task upon the reception of a control protocol message. This requirement heavily constrains the types of entries that are acceptable for the Performance Metrics Registry.
Report protocol:
This type of protocol is used to allow an entity to report measurement results to another entity. By referencing to a specific Performance Metrics Registry, it is possible to properly characterize the measurement result data being reported. Using the LMAP terminology, the Performance Metrics Registry is used in the LMAP Report Protocol to allow a Measurement Agent to report measurement results to a Collector.
It should be noted that the LMAP framework explicitly allows for using not only the IANA-maintained Performance Metrics Registry but also other registries containing Performance Metrics, i.e., either (1) registries defined by other organizations or (2) private registries.
However, others who are creating Registries to be used in the context of an LMAP framework are encouraged to use the Registry format defined in this document, because this makes it easier for developers of LMAP Measurement Agents to programmatically use information found in those other Registries' entries.
Single Point of Reference for Performance Metrics
A Performance Metrics Registry serves as a single point of reference for Performance Metrics defined in different working groups in the IETF. As we mentioned earlier, there are several working groups that define Performance Metrics in the IETF, and it is hard to keep track of all of them. This results in multiple definitions of similar Performance Metrics that attempt to measure the same phenomena but in slightly different (and incompatible) ways. Having a registry would allow the IETF community and others to have a single list of relevant Performance Metrics defined by the IETF (and others, where appropriate). The single list is also an essential aspect of communication about Performance Metrics, where different entities that request measurements, execute measurements, and report the results can benefit from a common understanding of the referenced Performance Metric.
Side Benefits
There are a couple of side benefits of having such a registry. First, the Performance Metrics Registry could serve as an inventory of useful and used Performance Metrics that are normally supported by different implementations of measurement agents. Second, the results of measurements using the Performance Metrics should be comparable even if they are performed by different implementations and in different networks, as the Performance Metric is properly defined. BCP 176 [RFC6576] examines whether the results produced by independent implementations are equivalent in the context of evaluating the completeness and clarity of metric specifications. [RFC6576] defines the Standards Track advancement testing for (active) IPPM metrics, and the same process will likely suffice to determine whether Registered Performance Metrics are sufficiently well specified to result in comparable (or equivalent) results.
Registered Performance Metrics that have undergone such testing SHOULD be noted, with a reference to the test results.
Criteria for Performance Metrics Registration
It is neither possible nor desirable to populate the Performance Metrics Registry with all combinations of Parameters of all Performance Metrics. The Registered Performance Metrics SHOULD be:
1. Interpretable by the user.
2. Implementable by the software or hardware designer.
3. Deployable by network operators.
4. Accurate in terms of producing equivalent results, and for interoperability and deployment across vendors.
5. Operationally useful, so that it has significant industry interest and/or has seen deployment.
6. Sufficiently tightly defined, so that different values for the Runtime Parameters do not change the fundamental nature of the measurement or change the practicality of its implementation.
In essence, there needs to be evidence that (1) a candidate Registered Performance Metric has significant industry interest or has seen deployment and (2) there is agreement that the candidate Registered Performance Metric serves its intended purpose.
Performance Metrics Registry: Prior Attempt
There was a previous attempt to define a metrics registry [RFC4148]. However, it was obsoleted by [RFC6248] because it was
"found to be insufficiently detailed to uniquely identify IPPM metrics... [there was too much] variability possible when characterizing a metric exactly",
which led to the metrics registry defined in [RFC4148] having "very few users, if any."
Three interesting additional quotes from [RFC6248] might help to understand the issues related to that registry.
1. "It is not believed to be feasible or even useful to register every possible combination of Type P, metric parameters, and Stream parameters using the current structure of the IPPM Metrics Registry."
2. "The current registry structure has been found to be insufficiently detailed to uniquely identify IPPM metrics."
3. "Despite apparent efforts to find current or even future users, no one responded to the call for interest in the RFC 4148 registry during the second half of 2010."
The current approach learns from this by tightly defining each Registered Performance Metric with only a few variable (Runtime) Parameters to be specified by the measurement designer, if any. The idea is that entries in the Performance Metrics Registry stem from different measurement methods that require input (Runtime) parameters to set factors like source and destination addresses (which do not change the fundamental nature of the measurement). The downside of this approach is that it could result in a large number of entries in the Performance Metrics Registry. There is agreement that less is more in this context -- it is better to have a reduced set of useful metrics rather than a large set of metrics, some with questionable usefulness.
Why This Attempt Should Succeed
As mentioned in the previous section, one of the main issues with the previous registry was that the metrics contained in the registry were too generic to be useful. This document specifies stricter criteria for performance metric registration (see Section 5) and imposes a group of Performance Metrics Experts that will provide guidelines to assess if a Performance Metric is properly specified.
Another key difference between this attempt and the previous one is that in this case there is at least one clear user for the Performance Metrics Registry: the LMAP framework and protocol. Because the LMAP protocol will use the Performance Metrics Registry values in its operation, this actually helps to determine if a metric is properly defined -- in particular, since we expect that the LMAP Control Protocol will enable a Controller to request that a measurement agent perform a measurement using a given metric by embedding the Performance Metrics Registry identifier in the protocol. Such a metric and method are properly specified if they are defined well enough so that it is possible (and practical) to implement them in the measurement agent. This was the failure of the previous attempt: a registry entry with an undefined Type-P (Section 13 of [RFC2330]) allows implementation to be ambiguous.
Definition of the Performance Metrics Registry
This Performance Metrics Registry is applicable to Performance Metrics used for Active Measurement, Passive Measurement, and any other form of Performance Measurement. Each category of measurement has unique properties, so some of the columns defined below are not applicable for a given metric category. In this case, the column(s) SHOULD be populated with the "N/A" value (Not Applicable). However, the "N/A" value MUST NOT be used by any metric in the following columns: Identifier, Name, URI, Status, Requester, Revision, Revision Date, Description. In the future, a new category of metrics could require additional columns, and adding new columns is a recognized form of registry extension. The specification defining the new column(s) MUST give general guidelines for populating the new column(s) for existing entries.
The columns of the Performance Metrics Registry are defined below. The columns are grouped into "Categories" to facilitate the use of the registry. Categories are described at the "Section 7.x" heading level, and columns are described at the "Section 7.x.y" heading level. The figure below illustrates this organization. An entry (row) therefore gives a complete description of a Registered Performance Metric.
Each column serves as a checklist item and helps to avoid omissions during registration and Expert Review [RFC8126].
=====================================================================
Legend:
    Registry Categories and Columns are shown below as:
    Category
    ------------------...
    Column |  Column |...
=====================================================================
Summary
----------------------------------------------------------------
Identifier | Name | URI | Desc. | Reference | Change     | Ver |
           |      |     |       |           | Controller |

Metric Definition
-----------------------------------------
Reference Definition | Fixed Parameters |

Method of Measurement
---------------------------------------------------------------------
Reference | Packet     | Traffic | Sampling     | Runtime    | Role |
Method    | Stream     | Filter  | Distribution | Parameters |      |
          | Generation |
Output
-----------------------------------------
Type | Reference  | Units | Calibration |
     | Definition |       |             |

Administrative Information
-------------------------------------
Status |Requester | Rev | Rev. Date |

Comments and Remarks
--------------------
There is a blank template of the Registry template provided in Section 11 of this memo.
Summary Category
Identifier
This entry provides a numeric identifier for the Registered Performance Metric. This identifier MUST be unique within the Performance Metrics Registry.
The Registered Performance Metric unique identifier is an unbounded integer (range 0 to infinity).
The Identifier 0 should be Reserved. The Identifier values from 64512 to 65536 are reserved for private or experimental use, and the user may encounter overlapping uses.
When adding new Registered Performance Metrics to the Performance Metrics Registry, IANA SHOULD assign the lowest available identifier to the new Registered Performance Metric.
If a Performance Metrics Expert providing review determines that there is a reason to assign a specific numeric identifier, possibly leaving a temporary gap in the numbering, then the Performance Metrics Expert SHALL inform IANA of this decision.
Name
As the name of a Registered Performance Metric is the first thing a potential human implementer will use when determining whether it is suitable for their measurement study, it is important to be as precise and descriptive as possible. In the future, users will review the names to determine if the metric they want to measure has already been registered, or if a similar entry is available, as a basis for creating a new entry.
Names are composed of the following elements, separated by an underscore character "_":
- MetricType_Method_SubTypeMethod_... Spec_Units_Output
MetricType:
A combination of the directional properties and the metric measured, such as and not limited to:
- RTDelay (Round-Trip Delay)
- RTDNS (Response Time Domain Name Service)
- RLDNS (Response Loss Domain Name Service)
- OWDelay (One-Way Delay)
- RTLoss (Round-Trip Loss)
- OWLoss (One-Way Loss)
- OWPDV (One-Way Packet Delay Variation)
- OWIPDV (One-Way Inter-Packet Delay Variation)
- OWReorder (One-Way Packet Reordering)
- OWDuplic (One-Way Packet Duplication)
- OWBTC (One-Way Bulk Transport Capacity)
- OWMBM (One-Way Model-Based Metric)
- SPMonitor (Single-Point Monitor)
- MPMonitor (Multi-Point Monitor)
Method:
One of the methods defined in [RFC7799], such as and not limited to:
- Active (depends on a dedicated measurement packet stream and observations of the stream)
- Passive (depends *solely* on observation of one or more existing packet streams)
- Hybrid Type I (observations on one stream that combine both active and passive methods)
- Hybrid Type II (observations on two or more streams that combine both active and passive methods)
- Spatial (spatial metric as described in [RFC5644])
SubTypeMethod:
One or more subtypes to further describe the features of the entry, such as and not limited to:
- ICMP (Internet Control Message Protocol)
- IP (Internet Protocol)
- DSCPxx (where xx is replaced by a Diffserv code point)
- UDP (User Datagram Protocol)
- TCP (Transport Control Protocol)
- QUIC (QUIC transport protocol)
- HS (Hand-Shake, such as TCP's 3-way HS)
- Poisson (packet generation using Poisson distribution)
- Periodic (periodic packet generation)
- SendOnRcv (sender keeps one packet in transit by sending when previous packet arrives)
- PayloadxxxxB (where xxxx is replaced by an integer, the number of octets in the payload)
- SustainedBurst (capacity test, worst case)
- StandingQueue (test of bottleneck queue behavior)
SubTypeMethod values are separated by a hyphen "-" character, which indicates that they belong to this element and that their order is unimportant when considering name uniqueness.
Spec:
An immutable document identifier combined with a document section identifier. For RFCs, this consists of the RFC number and major section number that specifies this Registry entry in the form "RFCXXXXsecY", e.g., RFC7799sec3. Note: The RFC number is not the primary reference specification for the metric definition, such as [RFC7679] for one-way delay; it will contain the placeholder "RFCXXXXsecY" until the RFC number is assigned to the specifying document and would remain blank in private registry entries without a corresponding RFC.
Anticipating the "RFC10K" problem, the number of the RFC continues to replace "RFCXXXX", regardless of the number of digits in the RFC number. Anticipating Registry Entries from other standards bodies, the form of this Name Element MUST be proposed and reviewed for consistency and uniqueness by the Expert Reviewer.
Units:
The units of measurement for the output, such as and not limited to:
- Seconds
- Ratio (unitless)
- Percent (value multiplied by 100%)
- Logical (1 or 0)
- Packets
- BPS (bits per second)
- PPS (packets per second)
- EventTotal (for unitless counts)
- Multiple (more than one type of unit)
- Enumerated (a list of outcomes)
- Unitless
Output:
The type of output resulting from measurement, such as and not limited to:
- Singleton
- Raw (multiple singletons)
- Count
- Minimum
- Maximum
- Median
- Mean
- 95Percentile (95th percentile)
- 99Percentile (99th percentile)
- StdDev (standard deviation)
- Variance
- PFI (pass, fail, inconclusive)
- FlowRecords (descriptions of flows observed)
- LossRatio (lost packets to total packets, <=1)
An example, as described in Section 4 of [RFCYYY1], is
- RTDelay_Active_IP-UDP-Periodic_RFCXXXXsecY_Seconds_95Percentile
Note that private registries following the format described here SHOULD use the prefix "Priv_" on any name to avoid unintended conflicts (further considerations are described in Section 10). Private registry entries usually have no specifying RFC; thus, the Spec: element has no clear interpretation.
URI
The URI column MUST contain a URL [RFC3986] that uniquely identifies and locates the metric entry so it is accessible through the Internet. The URL points to a file containing all of the human-readable information for one registry entry. The URL SHALL reference a target file that is preferably HTML-formatted and contains URLs to referenced sections of HTMLized RFCs, or other reference specifications. These target files for different entries can be more easily edited and reused when preparing new entries. The exact form of the URL for each target file, and the target file itself, will be determined by IANA and reside on https://www.iana.org/. Section 4 of [RFCYYY1], as well as subsequent major sections of that document, provide an example of a target file in HTML form.
Description
A Registered Performance Metric description is a written representation of a particular Performance Metrics Registry entry. It supplements the Registered Performance Metric name to help Performance Metrics Registry users select relevant Registered Performance Metrics.
Reference
This entry gives the specification containing the candidate registry entry that was reviewed and agreed upon, if such an RFC or other specification exists.
Change Controller
This entry names the entity responsible for approving revisions to the registry entry and SHALL provide contact information (for an individual, where appropriate).
Version (of Registry Format)
This entry gives the version number for the registry format used. Formats complying with this memo MUST use 1.0. The version number SHALL NOT change unless a new RFC is published that changes the registry format. The version number of registry entries SHALL NOT change unless the registry entry is updated (following the procedures in Section 8).
Metric Definition Category
This category includes columns to prompt all necessary details related to the metric definition, including the immutable document reference and values of input factors, called "fixed parameters", which are left open in the immutable document but have a particular value defined by the performance metric.
Reference Definition
This entry provides a reference (or references) to the relevant sections of the document or documents that define the metric, as well as any supplemental information needed to ensure an unambiguous definition for implementations.
A given reference needs to be an immutable document, such as an RFC; for other standards bodies, it is likely to be necessary to reference a specific, dated version of a specification.
Fixed Parameters
Fixed Parameters are Parameters whose values must be specified in the Performance Metrics Registry. The measurement system uses these values.
Where referenced metrics supply a list of Parameters as part of their descriptive template, a subset of the Parameters will be designated as Fixed Parameters. As an example for active metrics, Fixed Parameters determine most or all of the IPPM framework convention "packets of Type-P" as described in [RFC2330], such as transport protocol, payload length, TTL, etc. An example for passive metrics is for an RTP packet loss calculation that relies on the validation of a packet as RTP, which is a multi-packet validation controlled by MIN_SEQUENTIAL as defined by [RFC3550]. Varying MIN_SEQUENTIAL values can alter the loss report, and this value could be set as a Fixed Parameter.
Parameters MUST have well-defined names. For human readers, the hanging-indent style is preferred, and any Parameter names and definitions that do not appear in the Reference Method Specification MUST appear in this column (or the Runtime Parameters column).
Parameters MUST have a well-specified data format.
A Parameter that is a Fixed Parameter for one Performance Metrics Registry entry may be designated as a Runtime Parameter for another Performance Metrics Registry entry.
Method of Measurement Category
This category includes columns for references to relevant sections of the immutable document(s) and any supplemental information needed to ensure an unambiguous method for implementations.
Reference Method
This entry provides references to relevant sections of immutable documents, such as RFC(s) (for other standards bodies, it is likely to be necessary to reference a specific, dated version of a specification) describing the method of measurement, as well as any supplemental information needed to ensure unambiguous interpretation for implementations referring to the immutable document text.
Specifically, this section should include pointers to pseudocode or actual code that could be used for an unambiguous implementation.
Packet Stream Generation
This column applies to Performance Metrics that generate traffic as part of their Measurement Method, including, but not necessarily limited to, Active metrics. The generated traffic is referred to as a "stream", and this column describes its characteristics.
Each entry for this column contains the following information:
Value:
The name of the packet stream scheduling discipline
Reference:
The specification where the parameters of the stream are defined
The packet generation stream may require parameters such as the average packet rate and distribution truncation value for streams with Poisson-distributed inter-packet sending times. If such parameters are needed, they should be included in either the Fixed Parameters column or the Runtime Parameters column, depending on whether they will be fixed or will be an input for the metric.
The simplest example of stream specification is singleton scheduling (see [RFC2330]), where a single atomic measurement is conducted. Each atomic measurement could consist of sending a single packet (such as a DNS request) or sending several packets (for example, to request a web page). Other streams support a series of atomic measurements in a "sample", with a schedule defining the timing between each transmitted packet and subsequent measurement. Principally, two different streams are used in IPPM metrics: (1) Poisson, distributed as described in [RFC2330] and (2) periodic, as described in [RFC3432]. Both Poisson and periodic have their own unique parameters, and the relevant set of parameter names and values should be included in either the Fixed Parameters column or the Runtime Parameters column.
Traffic Filter
This column applies to Performance Metrics that observe packets flowing through (the device with) the measurement agent, i.e., that is not necessarily addressed to the measurement agent.
This includes, but is not limited to, Passive Metrics. The filter specifies the traffic that is measured. This includes protocol field values/ranges, such as address ranges, and flow or session identifiers.
The traffic filter itself depends on the needs of the metric itself and a balance of an operator's measurement needs and a user's need for privacy. Mechanics for conveying the filter criteria might be the BPF (Berkeley Packet Filter) or PSAMP (Packet Sampling) [RFC5475] Property Match Filtering, which reuses IPFIX [RFC7012]. An example BPF string for matching TCP/80 traffic to remote destination net 192.0.2.0/24 would be "dst net 192.0.2.0/24 and tcp dst port 80". Filter engines that are more complex might be supported by the implementation that might allow for matching using Deep Packet Inspection (DPI) technology.
The traffic filter includes the following information:
Type:
The type of traffic filter used, e.g., BPF, PSAMP, OpenFlow rule, etc., as defined by a normative reference
Value:
The actual set of rules expressed
Sampling Distribution
The sampling distribution defines, out of all of the packets that match the traffic filter, which one of those are actually used for the measurement. One possibility is "all", which implies that all packets matching the traffic filter are considered, but there may be other sampling strategies.
It includes the following information:
Value:
The name of the sampling distribution
Reference definition:
Pointer to the specification where the sampling distribution is properly defined
The sampling distribution may require parameters. If such parameters are needed, they should be included in either the Fixed Parameters column or the Runtime Parameters column, depending on whether they will be fixed or will be an input for the metric.
PSAMP is documented in "Sampling and Filtering Techniques for IP Packet Selection" [RFC5475], while "A Framework for Packet Selection and Reporting" [RFC5474] provides more background information. The sampling distribution parameters might be expressed in terms of the model described in "Information Model for Packet Sampling Exports" [RFC5477] and the process provided in "Flow Selection Techniques" [RFC7014].
Runtime Parameters
Runtime Parameters are Parameters that must be determined, configured into the measurement system, and reported with the results for the context to be complete. However, the values of these parameters are not specified in the Performance Metrics Registry (like the Fixed Parameters); rather, these parameters are listed as an aid to the measurement system implementer or user (they must be left as variables, and supplied on execution).
Where metrics supply a list of Parameters as part of their descriptive template, a subset of the Parameters will be designated as Runtime Parameters.
Parameters MUST have well-defined names. For human readers, the hanging-indent style is preferred, and the names and definitions that do not appear in the Reference Method Specification MUST appear in this column.
A data format for each Runtime Parameter MUST be specified in this column, to simplify the control and implementation of measurement devices. For example, parameters that include an IPv4 address can be encoded as a 32-bit integer (i.e., a binary base64-encoded value) or "ip address" as defined in [RFC6991]. The actual encoding(s) used must be explicitly defined for each Runtime parameter. IPv6 addresses and options MUST be accommodated, allowing Registered Performance Metrics to be used in that address family. Other address families are permissible.
Examples of Runtime Parameters include IP addresses, measurement point designations, start times and end times for measurement, and other information essential to the method of measurement.
Role
In some methods of measurement, there may be several roles defined, e.g., for a one-way packet delay active measurement, there is one measurement agent that generates the packets and another agent that receives the packets. This column contains the name of the Role(s) for this particular entry. In the one-way delay example above, there should be two entries in the registry's Role column, one for each Role (Source and Destination). When a measurement agent is instructed to perform the "Source" Role for the one-way delay metric, the agent knows that it is required to generate packets. The values for this field are defined in the reference method of measurement (and this frequently results in abbreviated role names such as "Src").
When the Role column of a registry entry defines more than one Role, the Role SHALL be treated as a Runtime Parameter and supplied for execution. It should be noted that the LMAP framework [RFC7594] distinguishes the Role from other Runtime Parameters and defines a special parameter, "Roles", inside the registry-grouping function list in the LMAP YANG model [RFC8194].
Output Category
For entries that involve a stream and many singleton measurements, a statistic may be specified in this column to summarize the results to a single value. If the complete set of measured singletons is output, this will be specified here.
Some metrics embed one specific statistic in the reference metric definition, while others allow several output types or statistics.
Type
This column contains the name of the output type. The output type defines a single type of result that the metric produces. It can be the raw results (packet send times and singleton metrics), or it can be a summary statistic. The specification of the output type MUST define the format of the output. In some systems, format specifications will simplify both measurement implementation and collection/storage tasks. Note that if two different statistics are required from a single measurement (for example, both "Xth percentile mean" and "Raw"), then a new output type must be defined ("Xth percentile mean AND Raw"). See the Naming section above for a list of output types.
Reference Definition
This column contains a pointer to the specification(s) where the output type and format are defined.
Metric Units
The measured results must be expressed using some standard dimension or units of measure. This column provides the units.
When a sample of singletons (see Section 11 of [RFC2330] for definitions of these terms) is collected, this entry will specify the units for each measured value.
Calibration
Some specifications for Methods of Measurement include the ability to perform an error calibration. Section 3.7.3 of [RFC7679] is one example. In the registry entry, this field will identify a method of calibration for the metric, and, when available, the measurement system SHOULD perform the calibration when requested and produce the output with an indication that it is the result of a calibration method. In situ calibration could be enabled with an internal loopback that includes as much of the measurement system as possible, performs address manipulation as needed, and provides some form of isolation (e.g., deterministic delay) to avoid send-receive interface contention. Some portion of the random and systematic error can be characterized in this way.
For one-way delay measurements, the error calibration must include an assessment of the internal clock synchronization with its external reference (this internal clock is supplying timestamps for measurement). In practice, the time offsets of clocks at both the source and destination are needed to estimate the systematic error due to imperfect clock synchronization (the time offsets are smoothed; thus, the random variation is not usually represented in the results).
Both internal loopback calibration and clock synchronization can be used to estimate the *available accuracy* of the Output Metric Units. For example, repeated loopback delay measurements will reveal the portion of the Output result resolution that is the result of system noise and is thus inaccurate.
Administrative Information
Status
This entry indicates the status of the specification of this Registered Performance Metric. Allowed values are 'current' and 'deprecated'. All newly defined Information Elements have 'current' status.
Requester
This entry indicates the requester for the Registered Performance Metric. The requester MAY be a document (such as an RFC) or a person.
Revision
This entry indicates the revision number of a Registered Performance Metric, starting at 0 for Registered Performance Metrics at the time of definition and incremented by one for each revision.
Revision Date
This entry indicates the date of acceptance of the most recent revision for the Registered Performance Metric. The date SHALL be determined by IANA and the reviewing Performance Metrics Expert.
Comments and Remarks
Besides providing additional details that do not appear in other categories, this open category (single column) allows for unforeseen issues to be addressed by simply updating this informational entry.
Processes for Managing the Performance Metrics Registry Group
Once a Performance Metric or set of Performance Metrics has been identified for a given application, candidate Performance Metrics Registry entry specifications prepared in accordance with Section 7 should be submitted to IANA to follow the process for review by the Performance Metrics Experts, as defined below. This process is also used for other changes to the Performance Metrics Registry, such as deprecation or revision, as described later in this section.
It is desirable that the author(s) of a candidate Performance Metrics Registry entry seek review in the relevant IETF working group or offer the opportunity for review on the working group mailing list.
Adding New Performance Metrics to the Performance Metrics Registry
Requests to add Registered Performance Metrics in the Performance Metrics Registry SHALL be submitted to IANA, which forwards the request to a designated group of experts (Performance Metrics Experts) appointed by the IESG; these are the reviewers called for by the Specification Required policy [RFC8126] defined for the Performance Metrics Registry. The Performance Metrics Experts review the request for such things as compliance with this document, compliance with other applicable Performance Metrics-related RFCs, and consistency with the currently defined set of Registered Performance Metrics. The most efficient path for submission begins with preparation of an Internet-Draft containing the proposed Performance Metrics Registry entry using the template in Section 11, so that the submission formatting will benefit from the normal IETF Internet-Draft submission processing (including HTMLization).
Submission to IANA may be during IESG review (leading to IETF Standards Action), where an Internet-Draft proposes one or more Registered Performance Metrics to be added to the Performance Metrics Registry, including the text of the proposed Registered Performance Metric(s).
If an RFC-to-be includes a Performance Metric and a proposed Performance Metrics Registry entry but the Performance Metrics Expert's review determines that one or more of the criteria listed in Section 5 have not been met, then the proposed Performance Metrics Registry entry MUST be removed from the text. Once evidence exists that the Performance Metric meets the criteria in Section 5, the proposed Performance Metrics Registry entry SHOULD be submitted to IANA to be evaluated in consultation with the Performance Metrics Experts for registration at that time.
Authors of proposed Registered Performance Metrics SHOULD review compliance with the specifications in this document to check their submissions before sending them to IANA.
At least one Performance Metrics Expert should endeavor to complete referred reviews in a timely manner. If the request is acceptable, the Performance Metrics Experts signify their approval to IANA, and IANA updates the Performance Metrics Registry. If the request is not acceptable, the Performance Metrics Experts MAY coordinate with the requester to change the request so that it is compliant; otherwise, IANA SHALL coordinate resolution of issues on behalf of the expert. The Performance Metrics Experts MAY choose to reject clearly frivolous or inappropriate change requests outright, but such exceptional circumstances should be rare.
This process should not in any way be construed as allowing the Performance Metrics Experts to overrule IETF consensus. Specifically, any Registered Performance Metrics that were added to the Performance Metrics Registry with IETF consensus require IETF consensus for revision or deprecation.
Decisions by the Performance Metrics Experts may be appealed per Section 7 of [RFC8126].
Revising Registered Performance Metrics
A request for revision is only permitted when the requested changes maintain backward compatibility with implementations of the prior Performance Metrics Registry entry describing a Registered Performance Metric (entries with lower revision numbers but having the same Identifier and Name).
The purpose of the Status field in the Performance Metrics Registry is to indicate whether the entry for a Registered Performance Metric is 'current' or 'deprecated'.
In addition, no policy is defined for revising the Performance Metric entries in the IANA registry or addressing errors therein. To be clear, changes and deprecations within the Performance Metrics Registry are not encouraged and should be avoided to the extent possible. However, in recognition that change is inevitable, the provisions of this section address the need for revisions.
Revisions are initiated by sending a candidate Registered Performance Metric definition to IANA, per Section 8.1, identifying the existing Performance Metrics Registry entry, and explaining how and why the existing entry should be revised.
The primary requirement in the definition of procedures for managing changes to existing Registered Performance Metrics is avoidance of measurement interoperability problems; the Performance Metrics Experts must work to maintain interoperability above all else. Changes to Registered Performance Metrics may only be done in an interoperable way; necessary changes that cannot be done in a way that allows interoperability with unchanged implementations MUST result in the creation of a new Registered Performance Metric (with a new Name, replacing the RFCXXXXsecY portion of the name) and possibly the deprecation of the earlier metric.
A change to a Registered Performance Metric SHALL be determined to be backward compatible when:
1. it involves the correction of an error that is obviously only editorial, or
2. it corrects an ambiguity in the Registered Performance Metric's definition, which itself leads to issues severe enough to prevent the Registered Performance Metric's usage as originally defined, or
3. it corrects missing information in the metric definition without changing its meaning (e.g., the explicit definition of 'quantity' semantics for numeric fields without a Data Type Semantics value), or
4. it harmonizes with an external reference that was itself corrected.
If a Performance Metric revision is deemed permissible and backward compatible by the Performance Metrics Experts, according to the rules in this document, IANA SHOULD execute the change(s) in the Performance Metrics Registry. The requester of the change is appended to the original requester in the Performance Metrics Registry. The Name of the revised Registered Performance Metric, including the RFCXXXXsecY portion of the name, SHALL remain unchanged (even when the change is the result of IETF Standards Action; the revised registry entry SHOULD reference the new immutable document, such as an RFC or for other standards bodies, it is likely to be necessary to reference a specific, dated version of a specification, in an appropriate category and column).
Each Registered Performance Metric in the Performance Metrics Registry has a revision number, starting at zero. Each change to a Registered Performance Metric following this process increments the revision number by one.
When a revised Registered Performance Metric is accepted into the Performance Metrics Registry, the date of acceptance of the most recent revision is placed into the revision Date column of the registry for that Registered Performance Metric.
Where applicable, additions to Registered Performance Metrics in the form of text in the Comments or Remarks column should include the date, but such additions may not constitute a revision according to this process.
Older versions of the updated metric entries are kept in the registry for archival purposes. The older entries are kept with all fields unmodified (version, revision date) except for the status field, which SHALL be changed to "Deprecated".
Deprecating Registered Performance Metrics
Changes that are not permissible by the above criteria for a Registered Performance Metric's revision may only be handled by deprecation. A Registered Performance Metric MAY be deprecated and replaced when:
1. the Registered Performance Metric definition has an error or shortcoming that cannot be permissibly changed per Section 8.2 ("Revising Registered Performance Metrics"), or
2. the deprecation harmonizes with an external reference that was itself deprecated through that reference's accepted deprecation method.
A request for deprecation is sent to IANA, which passes it to the Performance Metrics Experts for review. When deprecating a Performance Metric, the Performance Metric description in the Performance Metrics Registry must be updated to explain the deprecation, as well as to refer to any new Performance Metrics created to replace the deprecated Performance Metric.
The revision number of a Registered Performance Metric is incremented upon deprecation, and the revision Date is updated, as with any revision.
The intentional use of deprecated Registered Performance Metrics should result in a log entry or human-readable warning by the respective application.
Names and Metric IDs of deprecated Registered Performance Metrics must not be reused.
The deprecated entries are kept with all fields unmodified, except the version, the revision date, and the status field (changed to "Deprecated").
Security Considerations
This document defines a registry structure and does not itself introduce any new security considerations for the Internet. The definition of Performance Metrics for this registry may introduce some security concerns, but the mandatory references should have their own considerations for security, and such definitions should be reviewed with security in mind if the security considerations are not covered by one or more reference standards.
The aggregated results of the performance metrics described in this registry might reveal network topology information that may be considered sensitive. If such cases are found, then access control mechanisms should be applied.
IANA Considerations
With the background and processes described in earlier sections, this document requests the following IANA actions.
Editor's Note: Mock-ups of the implementation of this set of requests have been prepared with IANA's help during development of this memo and have been captured in the proceedings of IPPM working group sessions. IANA is currently preparing a mock-up. A recent version is available at http://encrypted.net/IETFMetricsRegistry-106.html.
Registry Group
The new registry group SHALL be named "PERFORMANCE METRICS Group".
Registration Procedure: Specification Required
Reference: RFC 0000
Experts: Performance Metrics Experts
Note: TBD
Performance Metric Name Elements
This document specifies the procedure for Performance Metrics Name Element Registry setup. IANA is requested to create a new set of registries for Performance Metric Name Elements called "Registered Performance Metric Name Elements". Each registry, whose names are listed below, will contain the current set of possibilities for Performance Metrics Registry Entry Names.
- MetricType:
- Method:
- SubTypeMethod:
- Spec:
- Units:
- Output:
To populate the Registered Performance Metric Name Elements at creation, the IANA is asked to use the lists of values for each name element listed in Section 7.1.2. The Name Elements in each registry are case sensitive.
When preparing a Metric entry for registration, the developer SHOULD choose Name elements from among the registered elements. However, if the proposed metric is unique in a significant way, it may be necessary to propose a new Name element to properly describe the metric, as described below.
A candidate Metric Entry RFC or immutable document for IANA and Expert Review would propose one or more new element values required to describe the unique entry, and the new name element(s) would be reviewed along with the metric entry. New assignments for Registered Performance Metric Name Elements will be administered by IANA through the Specification Required policy [RFC8126] (which includes Expert Review, i.e., review by one of a group of experts -- in the case of this document, the Performance Metrics Experts, who are appointed by the IESG upon recommendation of the Transport Area Directors).
New Performance Metrics Registry
This document specifies the procedure for Performance Metrics Registry setup. IANA is requested to create a new registry for Performance Metrics called "Performance Metrics Registry". This registry will contain the following Summary columns:
- Identifier:
- Name:
- URI:
- Description:
- Reference:
- Change Controller:
- Version:
Descriptions of these columns and additional information found in the template for registry entries (categories and columns) are further defined in Section 7.
The Identifier 0 should be Reserved. The Registered Performance Metric unique identifier is an unbounded integer (range 0 to infinity). The Identifier values from 64512 to 65536 are reserved for private or experimental use, and the user may encounter overlapping uses. When adding new Registered Performance Metrics to the Performance Metrics Registry, IANA SHOULD assign the lowest available identifier to the new Registered Performance Metric. If a Performance Metrics Expert providing review determines that there is a reason to assign a specific numeric identifier, possibly leaving a temporary gap in the numbering, then the Performance Metrics Expert SHALL inform IANA of this decision.
Names starting with the prefix "Priv_" are reserved for private use and are not considered for registration. The Name column entries are further defined in Section 7.
The URI column will have a URL to the full template of each registry entry. The Registry Entry text SHALL be HTMLized to aid the reader, with links to reference RFCs (similar to the way that Internet-Drafts are HTMLized, the same tool can perform the function) or an immutable document.
The Reference column will include an RFC number, an approved specification designator from another standards body, or some other immutable document.
New assignments for the Performance Metrics Registry will be administered by IANA through the Specification Required policy [RFC8126] (which includes Expert Review, i.e., review by one of a group of experts -- in the case of this document, the Performance Metrics Experts, who are appointed by the IESG upon recommendation of the Transport Area Directors) or by Standards Action. The experts can be initially drawn from the Working Group Chairs, document editors, and members of the Performance Metrics Directorate, among other sources of experts.
Extensions of the Performance Metrics Registry require IETF Standards Action. Only one form of registry extension is envisaged:
- Adding columns, or both categories and columns, to accommodate unanticipated aspects of new measurements and metric categories.
If the Performance Metrics Registry is extended in this way, the version number of future entries complying with the extension SHALL be incremented (in either the unit or the tenths digit, depending on the degree of extension).
Blank Registry Template
This section provides a blank template to help IANA and registry entry writers.
Summary
This category includes multiple indexes to the registry entry: the element ID and metric name.
ID (Identifier)
<insert a numeric identifier, an integer, TBD>
Name
<insert the name, according to the metric naming convention>
URI
URL: https://www.iana.org/ ... <name>
Description
<provide a description>
Change Controller
<provide information regarding the entity responsible for approving revisions to the registry entry (including contact information for an individual, where appropriate)>
Version (of Registry Format)
Metric Definition
This category includes columns to prompt the entry of all necessary details related to the metric definition, including the immutable document reference and values of input factors, called "fixed parameters".
Reference Definition
<provide a full bibliographic reference to an immutable document>
<provide a specific section reference and additional clarifications, if needed>
Fixed Parameters
<list and specify Fixed Parameters, input factors that must be determined and embedded in the measurement system for use when needed>
Method of Measurement
This category includes columns for references to relevant sections of the immutable document(s) and any supplemental information needed to ensure an unambiguous method for implementations.
Reference Method
<for the metric, insert relevant section references and supplemental info>
Packet Stream Generation
<provide a list of generation parameters and section/spec references if needed>
Traffic Filtering (Observation) Details
This category includes the measured results based on a filtered version of the packets observed, and this section reference provides the filter details (when present).
<provide a section reference>
Sampling Distribution
<insert time distribution details, or how this is different from the filter>
Runtime Parameters and Data Format
Runtime Parameters are input factors that must be determined, configured into the measurement system, and reported with the results for the context to be complete.
<provide a list of runtime parameters and their data formats>
Roles
<list the names of the different roles from the measurement method>
Output
This category specifies all details of the Output of measurements using the metric.
Type
<insert the name of the output type -- raw results or a selected summary statistic>
Reference Definition
<describe the reference data format for each type of result>
Metric Units
<insert units for the measured results, and provide the reference specification>
Calibration
<insert information on calibration>
Administrative Items
This category provides administrative information.
Status
<provide status: current or deprecated>
Requester
<provide a person's name, an RFC number, etc.>
Revision
<provide the revision number: 1.0>
Revision Date
<provide the date, in YYYY-MM-DD format>
Comments and Remarks
<list any additional (informational) details for this entry>
References
Normative References
Informative References
[RFCYYY1]

Initial Performance Metrics Registry Entries
RFC YYY1
DOI 10.17487/RFCYYY1
Alfred Morton
Marcelo Bagnulo
Philip Eardley
Kevin D'Souza
May 2020
[RFC6390]
[RFC3611]
[RFC3550]
[RFC6035]
[RFC2119]
[RFC8174]
[RFC2330]
[RFC8126]
[RFC7799]
[RFC7679]
[RFC2681]
[RFC6248]
[RFC7594]
[RFC6576]
[RFC4148]
[RFC5644]
[RFC3986]
[RFC3432]
[RFC5475]
[RFC7012]
[RFC5474]
[RFC5477]
[RFC7014]
[RFC6991]
[RFC8194]
Acknowledgments
Thanks to Brian Trammell and Bill Cerveny, IPPM chairs, for leading some brainstorming sessions on this topic. Thanks to Barbara Stark and Juergen Schoenwaelder for the detailed feedback and suggestions. Thanks to Andrew McGregor for suggestions on metric naming. Thanks to Michelle Cotton for her early IANA review, and to Amanda Barber for answering questions related to the presentation of the registry and accessibility of the complete template via URL.
Thanks to Roni Even for his review and suggestions to generalize the procedures. Thanks to ~all of the Area Directors for their reviews.